'******************************************************************************
'  ENC28J60 specific routines
'******************************************************************************

'*******************************************************************************
'  Pollin NET-IO Board with Atmega32 / 644 / 644P and ENC28J60
'*******************************************************************************
'
'  Copyright bascom-forum.de (C) [2009]  [DON]
'  -> http://bascom-forum.de/index.php?topic=1781.new;topicseen#new
'  Software based on Code by Ben Zijlstra and Viktor Varga
'  Weiterentwickelt von
'    Huetti,
'    Michael
'    boeserkorn
'    mr_energy
'    HansHans
'    six1, Michael Kcher
'    dabuze                            datetime
'    framuel
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'

'*******************************************************************************
$nocompile


' Einfacher Webserver mit Schaltfunktionen M32
#if Netio_mode = 1
   Const Include_enc28j60 = 1                               '0 = no, 1 = yes, 2 reserved
   Const Include_ip = 1                                     '0 = no, 1 = yes, 2 reserved
   Const Include_arp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_icmp = 0                                   '0 = no, 1 = yes, 2 reserved
   Const Include_dhcp = 0                                   '0 = no, 1 = yes, 2 reserved
   Const Include_dns = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_ntp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_udp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_tcp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_telnet = 0                                 '0 = no, 1 = yes, 2 reserved
   Const Include_http = 1
     Const Include_ajax = 0                                 '0 = no, 1 = yes, 2 reserved
     Const Include_javascript = 0
     Const Include_svg = 0
   Const Include_smtp = 0                                   '0 = no, 1 = yes, 2 reserved
   Const Include_sdcard = 0                                 '0 = no, 1 = yes, 2 reserved
   Const Include_switch = 0                                 '0 = no, 1 = yes, 2 reserved
   Const Include_temperatur = 0
   Const Include_cam = 0                                    'CAM Modul needs IP because of buffer() !
   Const Include_php_call = 0
   Const Include_lcd = 0
   Const Include_rs232_setup = 1
#endif

' Aufruf einer PHP Seite und Abspeichern von Temperaturen M32
#if Netio_mode = 2
   Const Include_enc28j60 = 1                               '0 = no, 1 = yes, 2 reserved
   Const Include_ip = 1                                     '0 = no, 1 = yes, 2 reserved
   Const Include_arp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_icmp = 1                                   '0 = no, 1 = yes, 2 reserved
   Const Include_dhcp = 1                                   '0 = no, 1 = yes, 2 reserved
   Const Include_dns = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_ntp = 0                                    '0 = no, 1 = yes, 2 reserved
   Const Include_udp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_tcp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_telnet = 0                                 '0 = no, 1 = yes, 2 reserved
   Const Include_http = 0
     Const Include_ajax = 0                                 '0 = no, 1 = yes, 2 reserved
     Const Include_javascript = 0
     Const Include_svg = 0
   Const Include_smtp = 0                                   '0 = no, 1 = yes, 2 reserved
   Const Include_sdcard = 0                                 '0 = no, 1 = yes, 2 reserved
   Const Include_switch = 0                                 '0 = no, 1 = yes, 2 reserved
   Const Include_temperatur = 1
   Const Include_cam = 0                                    'CAM Modul needs IP because of buffer() !
   Const Include_php_call = 1
   Const Include_lcd = 0
   Const Include_rs232_setup = 1
#endif




#if Netio_mode = 3
   Const Include_enc28j60 = 1                               '0 = no, 1 = yes, 2 reserved
   Const Include_ip = 1                                     '0 = no, 1 = yes, 2 reserved
   Const Include_arp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_icmp = 1                                   '0 = no, 1 = yes, 2 reserved
   Const Include_dhcp = 1                                   '0 = no, 1 = yes, 2 reserved
   Const Include_dns = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_ntp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_udp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_tcp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_telnet = 0                                 '0 = no, 1 = yes, 2 reserved
   Const Include_http = 1                                   '0 = no, 1 = yes, 2 reserved
     Const Include_ajax = 0                                 '0 = no, 1 = yes, 2 reserved
     Const Include_javascript = 0
     Const Include_svg = 0
   Const Include_smtp = 0                                   '0 = no, 1 = yes, 2 reserved
   Const Include_sdcard = 1                                 '0 = no, 1 = yes, 2 reserved
   Const Include_switch = 1                                 '0 = no, 1 = yes, 2 reserved
   Const Include_temperatur = 0
   Const Include_cam = 0                                    'CAM Modul needs IP because of buffer() !
   Const Include_php_call = 0
   Const Include_lcd = 1
   Const Include_rs232_setup = 0
#endif




#if Netio_mode = 4
   Const Include_enc28j60 = 1                               '0 = no, 1 = yes, 2 reserved
   Const Include_ip = 1                                     '0 = no, 1 = yes, 2 reserved
   Const Include_arp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_icmp = 1                                   '0 = no, 1 = yes, 2 reserved
   Const Include_dhcp = 1                                   '0 = no, 1 = yes, 2 reserved
   Const Include_dns = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_ntp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_udp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_tcp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_telnet = 0                                 '0 = no, 1 = yes, 2 reserved
   Const Include_http = 1                                   '0 = no, 1 = yes, 2 reserved
     Const Include_ajax = 1                                 '0 = no, 1 = yes, 2 reserved
     Const Include_javascript = 1
     Const Include_svg = 0
   Const Include_smtp = 0                                   '0 = no, 1 = yes, 2 reserved
   Const Include_sdcard = 1                                 '0 = no, 1 = yes, 2 reserved
   Const Include_switch = 1                                 '0 = no, 1 = yes, 2 reserved
   Const Include_temperatur = 0
   Const Include_cam = 0                                    'CAM Modul needs IP because of buffer() !
   Const Include_php_call = 0
   Const Include_lcd = 1
   Const Include_rs232_setup = 0
#endif

#if Netio_mode = 5
   Const Include_enc28j60 = 1                               '0 = no, 1 = yes, 2 reserved
   Const Include_ip = 1                                     '0 = no, 1 = yes, 2 reserved
   Const Include_arp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_icmp = 1                                   '0 = no, 1 = yes, 2 reserved
   Const Include_dhcp = 1                                   '0 = no, 1 = yes, 2 reserved
   Const Include_dns = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_ntp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_udp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_tcp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_telnet = 0                                 '0 = no, 1 = yes, 2 reserved
   Const Include_http = 1                                   '0 = no, 1 = yes, 2 reserved
     Const Include_ajax = 1                                 '0 = no, 1 = yes, 2 reserved
     Const Include_javascript = 1
     Const Include_svg = 0
   Const Include_smtp = 0                                   '0 = no, 1 = yes, 2 reserved
   Const Include_sdcard = 1                                 '0 = no, 1 = yes, 2 reserved
   Const Include_switch = 1                                 '0 = no, 1 = yes, 2 reserved
   Const Include_temperatur = 1
   Const Include_cam = 1                                    'CAM Modul needs IP because of buffer() !
   Const Include_php_call = 0
   Const Include_lcd = 1
   Const Include_rs232_setup = 1
#endif

#if Netio_mode = 6
'(
Netio , Add -on Board , Cam , I2c Display Svg
')
   Const Include_enc28j60 = 1                               '0 = no, 1 = yes, 2 reserved
   Const Include_ip = 1                                     '0 = no, 1 = yes, 2 reserved
   Const Include_arp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_icmp = 1                                   '0 = no, 1 = yes, 2 reserved
   Const Include_dhcp = 1                                   '0 = no, 1 = yes, 2 reserved
   Const Include_dns = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_ntp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_udp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_tcp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_telnet = 0                                 '0 = no, 1 = yes, 2 reserved
   Const Include_http = 1                                   '0 = no, 1 = yes, 2 reserved
     Const Include_ajax = 1                                 '0 = no, 1 = yes, 2 reserved
     Const Include_javascript = 1
     Const Include_svg = 1
   Const Include_smtp = 0                                   '0 = no, 1 = yes, 2 reserved
   Const Include_sdcard = 1                                 '0 = no, 1 = yes, 2 reserved
   Const Include_switch = 1                                 '0 = no, 1 = yes, 2 reserved
   Const Include_temperatur = 1
   Const Include_cam = 1                                    'CAM Modul needs IP because of buffer() !
   Const Include_php_call = 0
   Const Include_lcd = 1
   Const Include_rs232_setup = 1
#endif



         'Smtp eMail HH   1/2011
#if Netio_mode = 7
   Const Include_enc28j60 = 1                               '0 = no, 1 = yes, 2 reserved
   Const Include_ip = 1                                     '0 = no, 1 = yes, 2 reserved
   Const Include_arp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_icmp = 1                                   '0 = no, 1 = yes, 2 reserved
   Const Include_dhcp = 1                                   '0 = no, 1 = yes, 2 reserved
   Const Include_dns = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_ntp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_udp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_tcp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_telnet = 0                                 '0 = no, 1 = yes, 2 reserved
   Const Include_http = 1                                   '0 = no, 1 = yes, 2 reserved
     Const Include_ajax = 0                                 '0 = no, 1 = yes, 2 reserved
     Const Include_javascript = 0
     Const Include_svg = 0
   Const Include_smtp = 1                                   '0 = no, 1 = yes, 2 reserved
   Const Include_sdcard = 0                                 '0 = no, 1 = yes, 2 reserved
   Const Include_switch = 0                                 '0 = no, 1 = yes, 2 reserved
   Const Include_temperatur = 0
   Const Include_cam = 0                                    'CAM Modul needs IP because of buffer() !
   Const Include_php_call = 0
   Const Include_lcd = 5                                    '5 = HH
   Const Include_rs232_setup = 1

   Const Include_anwendung = 0

#endif

         'Fr Freesol
#if Netio_mode = 90
   Const Include_enc28j60 = 1                               '0 = no, 1 = yes, 2 reserved
   Const Include_ip = 1                                     '0 = no, 1 = yes, 2 reserved
   Const Include_arp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_icmp = 1                                   '0 = no, 1 = yes, 2 reserved
   Const Include_dhcp = 1                                   '0 = no, 1 = yes, 2 reserved
   Const Include_dns = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_ntp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_udp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_tcp = 1                                    '0 = no, 1 = yes, 2 reserved
   Const Include_telnet = 0                                 '0 = no, 1 = yes, 2 reserved
   Const Include_http = 1                                   '0 = no, 1 = yes, 2 reserved
     Const Include_ajax = 0                                 '0 = no, 1 = yes, 2 reserved
     Const Include_javascript = 1
     Const Include_svg = 1
   Const Include_smtp = 1                                   '0 = no, 1 = yes, 2 reserved
   Const Include_sdcard = 0                                 '0 = no, 1 = yes, 2 reserved
   Const Include_switch = 0                                 '0 = no, 1 = yes, 2 reserved
   Const Include_temperatur = 0
   Const Include_cam = 0                                    'CAM Modul needs IP because of buffer() !
   Const Include_php_call = 0
   Const Include_lcd = 0                                    '5 = HH
   Const Include_rs232_setup = 1

   Const Include_anwendung = 2                              '2: Fr Freesol genutzt

#endif



'*******************************************************************************
'  Protocol specific declarations
'*******************************************************************************
$include "eeram_declarations.inc"

#if Include_enc28j60 > 0
    $include "enc28j60_declarations.inc"
#endif
#if Include_ip > 0
    $include "ip_declarations.inc"
#endif
#if Include_arp > 0
    $include "arp_declarations.inc"
#endif
#if Include_icmp > 0
    $include "icmp_declarations.inc"
#endif
#if Include_udp > 0
    $include "udp_declarations.inc"
#endif
#if Include_ntp > 0
    $include "ntp_declarations.inc"
#endif
#if Include_dhcp > 0
    $include "dhcp_declarations.inc"
#endif
#if Include_dns > 0
    $include "dns_declarations.inc"
#endif
#if Include_tcp > 0
    $include "tcp_declarations.inc"
#endif
#if Include_http > 0
    $include "http_declarations.inc"
#endif
#if Include_php_call > 0
    $include "php_call_declarations.inc"
#endif
#if Include_telnet > 0
    $include "telnet_declarations.inc"
#endif
#if Include_sdcard > 0
    $include "sd-card_declarations.inc"
#endif
#if Include_switch = 1
    Config Portc = Output
#endif
#if Include_temperatur > 0
    $include "temperatur_declarations.inc"
#endif
#if Include_cam > 0
    $include "cam_declarations.inc"
#endif

#if Include_lcd > 0
    $include "lcd_declarations.inc"
#endif

#if Include_rs232_setup = 1
    $include "rs232_setup_declarations.inc"
#endif

#if Include_smtp > 0
   $include "smtp_declarations_V4.inc"
#endif


#if Include_anwendung = 1
    $include "anwendung_declarations.inc"
#endif

' Freesol
#if Include_anwendung = 2
    $include "freesol_declarations.inc"
#endif
' Ende Freesol






$include "misc_declarations.inc"